<?php

namespace DTInternet\DtiOnlineconsulting\Controller;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2022 Stefan Bublies <bublies@dt-internet.de>
 *
 *  All rights reserved
 *
 ***************************************************************/

use \TYPO3\CMS\Core\Utility\GeneralUtility;
use \TYPO3\CMS\Extbase\Mvc\Controller\ActionController;
use DTInternet\DtiUsermanagement\Utility\FeuserUtility;

/**
 * (c) 2022 Stefan Bublies bublies@dt-internet.de
 */
class CategorieController extends ActionController
{
    /**
     * categoriesRepository
     *
     * @var \DTInternet\DtiOnlineconsulting\Domain\Repository\CategoriesRepository
     */
    protected $categoriesRepository = null;

    /**
     * @param \DTInternet\DtiOnlineconsulting\Domain\Repository\CategoriesRepository $categoriesRepository
     */
    public function injectCategoriesRepository(\DTInternet\DtiOnlineconsulting\Domain\Repository\CategoriesRepository $categoriesRepository)
    {
        $this->categoriesRepository = $categoriesRepository;
    }

    /**
     * @return void
     */
    public function categorieListAction()
    {
        $catId = \TYPO3\CMS\Core\Utility\GeneralUtility::_GP('catId');
        if(is_numeric($catId)) {
            $categorie = $this->categoriesRepository->findByUid($catId);
            $this->view->assign('categorie', $categorie);
        }
    }
}
