<?php
namespace DTInternet\DtiOnlineconsulting\Domain\Model;


/***
 *
 * This file is part of the "dti_onlineconsulting" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2022 Stefan Bublies <bublies@dt-internet.de>, D&T Internet GmbH
 *
 ***/

use DTInternet\DtiUsermanagement\Utility\FeuserUtility;

/**
 * Topics
 */
class Topics extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * Frage des Benutzers
     *
     * @var string
     */
    protected $bodytext = '';


    /**
     * Antworten
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\DTInternet\DtiOnlineconsulting\Domain\Model\Topicanswers>
     */
    protected $answers = null;

    /**
     * Benutzer:in
     */
    protected $feuser = '';

    /**
     * Agent
     *
     * @var int
     */
    protected $agent = '';

    /**
     * @var \DateTime
     */
    protected $crdate = null;

    /**
     * closed
     *
     * @var bool
     */
    protected $closed = false;

    /**
     * Userstate
     *
     * @var int
     */
    protected $userstate = '';

    /**
     * Agentstate
     *
     * @var int
     */
    protected $agentstate = '';

    /**
     * Returns the bodytext
     *
     * @return string $bodytext
     */
    public function getBodytext()
    {
        return $this->bodytext;
    }

    /**
     * Sets the bodytext
     *
     * @param string $bodytext
     * @return void
     */
    public function setBodytext($bodytext)
    {
        $this->bodytext = $bodytext;
    }

    /**
     * Adds a answers
     *
     * @param \DTInternet\DtiOnlineconsulting\Domain\Model\Topicanswers $answers
     * @return void
     */
    public function addAnswers(\DTInternet\DtiOnlineconsulting\Domain\Model\Topicanswers $answers)
    {
        $this->answers->attach($answers);
    }

    /**
     * Removes a answers
     *
     * @param \DTInternet\DtiOnlineconsulting\Domain\Model\Topicanswers $answersToRemove The Dates to be removed
     * @return void
     */
    public function removeAnswers(\DTInternet\DtiOnlineconsulting\Domain\Model\Topicanswers $answersToRemove)
    {
        $this->answers->detach($answersToRemove);
    }

    /**
     * Returns the answers
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\DTInternet\DtiOnlineconsulting\Domain\Model\Topicanswers> $answers
     */
    public function getAnswers()
    {
        return $this->answers;
    }

    /**
     * Sets the answers
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\DTInternet\DtiOnlineconsulting\Domain\Model\Topicanswers> $answers
     * @return void
     */
    public function setAnswers(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $answers)
    {
        $this->answers = $answers;
    }

    /**
     * Returns the feuser
     *
     */
    public function getFeuser()
    {
        return $this->feuser;
    }

    /**
     * Sets the feuser
     * @param int $feuser
     * @return void
     */
    public function setFeuser($feuser)
    {
        $this->feuser = $feuser;
    }

    /**
     * Returns the agent
     *
     * @return int $agent
     */
    public function getAgent()
    {
        return $this->agent;
    }

    /**
     * Sets the agent
     *
     * @param int $agent
     * @return void
     */
    public function setAgent($agent)
    {
        $this->agent = $agent;
    }


    /**
     * Returns the creation date
     *
     * @return \DateTime $crdate
     */
    public function getCrdate()
    {
        return $this->crdate;
    }

    /**
     * Returns the closed
     *
     * @return bool $closed
     */
    public function getClosed()
    {
        return $this->closed;
    }

    /**
     * Sets the closed
     *
     * @param bool $closed
     * @return void
     */
    public function setClosed($closed)
    {
        $this->closed = $closed;
    }

    /**
     * Returns the boolean state of closed
     *
     * @return bool
     */
    public function isClosed()
    {
        return $this->closed;
    }

    /**
     * FeUserData
     * @return mixed
     */
    public function getFeUserdata()
    {
        $feUserData = FeuserUtility::readFeUserDataSingle($this->feuser);
        return $feUserData;
    }

    /**
     * Returns the userstate
     *
     * @return int $userstate
     */
    public function getUserstate()
    {
        return $this->userstate;
    }

    /**
     * Sets the userstate
     *
     * @param int $userstate
     * @return void
     */
    public function setUserstate($userstate)
    {
        $this->userstate = $userstate;
    }

    /**
     * Returns the agentstate
     *
     * @return int $agentstate
     */
    public function getAgentstate()
    {
        return $this->agentstate;
    }

    /**
     * Sets the agentstate
     *
     * @param int $agentstate
     * @return void
     */
    public function setAgentstate($agentstate)
    {
        $this->agentstate = $agentstate;
    }

}
