<?php
namespace DTInternet\DtiOnlineconsulting\Services;

/***
 * This file is part of the "Salesforce" Extension for TYPO3 CMS.
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *  (c) 2022 Stefan Bublies <bublies@dt-internet.de>, D&T Internet GmbH
 ***/

use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Core\Database\Connection;
use TYPO3\CMS\Core\Database\ConnectionPool;
use TYPO3\CMS\Core\Database\Query\QueryBuilder;

class LiveChatData
{

    /**
     * * (c) 2022 Stefan Bublies
     */

    public function cleanTable()
    {
        $this->cleanLivechatTable();
    }

    public function cleanLivechatTable()
    {
        /** @var Connection $connection */
        $connection = GeneralUtility::makeInstance(ConnectionPool::class)->getConnectionForTable('tx_dtionlineconsulting_domain_model_livechat');
        /** @var QueryBuilder $queryBuilder */
        $queryBuilder = $connection->createQueryBuilder();
        $readChatDatas = $queryBuilder
            ->select('uid', 'crdate')
            ->from('tx_dtionlineconsulting_domain_model_livechat')
            ->execute()
            ->fetchAll(\Doctrine\DBAL\FetchMode::ASSOCIATIVE);

        $time = strtotime("now");
        foreach($readChatDatas as $data) {
            $difference_in_seconds = $time - $data['crdate'];
            if (round($difference_in_seconds/60) > 5) {
                $queryBuilder = $connection->createQueryBuilder();
                $queryBuilder
                    ->delete('tx_dtionlineconsulting_domain_model_livechat')
                    ->where(
                        $queryBuilder->expr()->eq('uid', $queryBuilder->createNamedParameter($data['uid'], \PDO::PARAM_INT))
                    )
                    ->execute();
            }
        }
    }
}
