<?php

namespace DTInternet\DtiOnlineconsulting\Utility;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2022 Stefan Bublies <bublies@dt-internet.de>
 *
 *  All rights reserved
 *
 ***************************************************************/

use TYPO3\CMS\Core\Database\ConnectionPool;
use TYPO3\CMS\Core\Utility\GeneralUtility;


class LivechatApiUtility
{

    /**
     * @param $uid
     * @return true
     */
    public static function checkAgent($uid)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, 'https://conf.'.self::getSettings()['identity'].'.apps.hosting:4000/supporters/'.self::getSettings()['identityPath']);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        $activeChats = curl_exec($ch);
        $aActiveChats = json_decode($activeChats, true);
        foreach($aActiveChats as $agent) {
            if ($agent == $uid) {
                return true;
            } else {
                return false;
            }
        }
    }

    /**
     * @return mixed
     */
    public static function checkAgents()
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, 'https://conf.'.self::getSettings()['identity'].'.apps.hosting:4000/supporters/'.self::getSettings()['identityPath']);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        $activeChats = curl_exec($ch);
        $aActiveChats = json_decode($activeChats, true);

        return $aActiveChats;
    }

    /**
     * Returns TypoSript settings array
     *
     * @param string $extension Name of the extension
     * @param string $plugin Name of the plugin
     * @return array
     */
    public static function getSettings()
    {
        $configurationManager = GeneralUtility::makeInstance('TYPO3\\CMS\\Extbase\\Configuration\\ConfigurationManager');

        $typoScript = $configurationManager->getConfiguration(
            \TYPO3\CMS\Extbase\Configuration\ConfigurationManagerInterface::CONFIGURATION_TYPE_FULL_TYPOSCRIPT);

        $settings = $typoScript['tx_dtionlineconsulting_settings.'];

        return $settings;
    }
}
