<?php
defined('TYPO3_MODE') || die('Access denied.');

if (version_compare(TYPO3_branch, '11.0', '>=')) {
    $moduleClass = \DTInternet\DtiOnlineconsulting\Controller\DirectmessageController::class;
    $moduleClassChat = \DTInternet\DtiOnlineconsulting\Controller\LivechatController::class;
    $moduleClassState = \DTInternet\DtiOnlineconsulting\Controller\StateController::class;
    $moduleClassCat = \DTInternet\DtiOnlineconsulting\Controller\CategorieController::class;
    $moduleClassVideo = \DTInternet\DtiOnlineconsulting\Controller\VideomeetController::class;
    $moduleClassApi = \DTInternet\DtiOnlineconsulting\Controller\ValidateApiController::class;
} else {
    $moduleClass = 'Directmessage';
    $moduleClassChat = 'Livechat';
    $moduleClassState = 'State';
    $moduleClassCat = 'Categorie';
    $moduleClassVideo = 'Videomeet';
    $moduleClassApi = 'ValidateApi';
}

\TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
    'DTInternet.DtiOnlineconsulting',
    'Directmessage',
    [
        $moduleClass => 'selection, add, chat, closedrequest, reopenrequest'
    ],
    // non-cacheable actions
    [
        $moduleClass => 'selection, add, chat, closedrequest, reopenrequest'
    ]
);

\TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
    'DTInternet.DtiOnlineconsulting',
    'Livechat',
    [
        $moduleClassChat => 'agents, generateLivechat'
    ],
    // non-cacheable actions
    [
        $moduleClassChat => 'agents, generateLivechat'
    ]
);

\TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
    'DTInternet.DtiOnlineconsulting',
    'State',
    [
        $moduleClassState => 'checkChat'
    ],
    // non-cacheable actions
    [
        $moduleClassState => 'checkChat'
    ]
);

\TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
    'DTInternet.DtiOnlineconsulting',
    'Categorie',
    [
        $moduleClassCat => 'categorieList'
    ],
    // non-cacheable actions
    [
    ]
);

\TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
    'DTInternet.DtiOnlineconsulting',
    'Videomeet',
    [
        $moduleClassVideo => 'videorequest, list, show, videorequestConfirm'
    ],
    // non-cacheable actions
    [
        $moduleClassVideo => 'videorequest, show, videorequestConfirm'
    ]
);


\TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
    'DTInternet.DtiOnlineconsulting',
    'Videomeetagent',
    [
        $moduleClassVideo => 'list, activate, decline, meetingRedirect'
    ],
    // non-cacheable actions
    [
        $moduleClassVideo => 'list, activate, decline, meetingRedirect'
    ]
);

\TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
    'DTInternet.DtiOnlineconsulting',
    'OnlineconsultingApi',
    [
        $moduleClassApi => 'validate'
    ],
    // non-cacheable actions
    [
        $moduleClassApi => 'validate'
    ]
);

// wizards
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPageTSConfig(
    'mod {
                        wizards.newContentElement.wizardItems.plugins {
                            elements {
                                directmessage {
                                    iconIdentifier = dti_usermanagement
                                    title = Chatfunktion
                                    description = Anfragen die innerhalb von 48 Stunden beantwortet werden
                                    tt_content_defValues {
                                        CType = list
                                        list_type = dtionlineconsulting_directmessage
                                    }
                                }
                                livechat {
                                    iconIdentifier = dti_usermanagement
                                    title = Live-Chat
                                    description = Anzeige von Agents für den Live-Chat
                                    tt_content_defValues {
                                        CType = list
                                        list_type = dtionlineconsulting_livechat
                                    }
                                }
                                categorie {
                                    iconIdentifier = dti_usermanagement
                                    title = Kategorie-Anzeige
                                    description = Anzeige der Kategorie inkl. weiteren Infos
                                    tt_content_defValues {
                                        CType = list
                                        list_type = dtionlineconsulting_categorie
                                    }
                                }
                                videomeet {
                                    iconIdentifier = dti_usermanagement
                                    title = Videoberatungstermine
                                    description = Terminanzeige und Vergabe für die Videoberatung
                                    tt_content_defValues {
                                        CType = list
                                        list_type = dtionlineconsulting_videomeet
                                    }
                                }
                                videomeetagent {
                                    iconIdentifier = dti_usermanagement
                                    title = Videoberatungstermine (Agent-Seite)
                                    description = Terminanzeige und Vergabe für die Videoberatung
                                    tt_content_defValues {
                                        CType = list
                                        list_type = dtionlineconsulting_videomeetagent
                                    }
                                }
                            }
                            show = *
                        }
                   }'
);

$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['scheduler']['tasks']['DTInternet\DtiOnlineconsulting\Tasks\CleanLiveChatTable'] = [
    'extension' => 'dti_onlineconsulting',
    'title' => 'LiveChat – Aufräumen der aktiven Chats',
    'description' => 'Job der alle 5 Minuten läuft um inaktive Chats zu entfernen'
];
